#include "awoorwae.h"
#include <cmath>
#include <string>

namespace pabloader {

bool Awoorwae::OnUserUpdate(float fElapsedTime)
{
    Clear(olc::BLACK);

    player->Update(fElapsedTime);
    player->Draw();
    return true;
}

Entity::Entity(Awoorwae* game_, float x_, float y_)
    : game(game_)
    , x(x_)
    , y(y_)
    , xv(50)
    , yv(30)
    , color(0)
{
    xv = 10;
    yv = 10;
}

void Entity::Update(float dt)
{
    x += dt * xv;
    y += dt * yv;

    if (x > game->ScreenWidth() - 20) {
        xv *= -1;
        x = game->ScreenWidth() - 20;
    }

    if (x < 20) {
        xv *= -1.1;
        x = 20;
    }

    if (y > game->ScreenHeight() - 20) {
        yv *= -1;
        y = game->ScreenHeight() - 20;
    }

    if (y < 20) {
        yv *= -1.1;
        y = 20;
    }
    color = fmodf(color + 256 * dt, 256);
}

void Entity::Draw()
{
    game->DrawCircle((int)x, (int)y, 20, olc::Pixel::CreateFromHSV((int)color, 255, 255));
}
}